#include "Class.ch"

#pragma Library( "XppUi2.lib" )

#define CRLF CHR(13)+CHR(10)

PROCEDURE Main
LOCAL oXbp
LOCAL oBrowse

   oXbp := XbpDialog():new( AppDesktop(),, {10,10}, {200,200} )
   oXbp:create()

   oBrowse := XbpBrowse():new( oXbp:DrawingArea):create()

   SET ALTERNATE TO Dialog.txt
   SET ALTERNATE ON

   InsObject2( oBrowse )
RETURN

PROCEDURE InsObject2(oObj)
LOCAL aItem
LOCAL i,iMax
LOCAL j,jMax
LOCAL cName
LOCAL cAttr

   ?"*****************************************************************************"
   ? oObj:className()+CRLF+CRLF
*   ? oObj:InterfaceName
   ?"*****************************************************************************"

   aItem := oObj:classDescribe()
   iMax := LEN(aItem)
   FOR i := 1 TO iMax
      jMax := LEN(aItem[i])
      DO CASE
         CASE i = CLASS_DESCR_CLASSNAME
            ? "CLASS_DESCR_CLASSNAME"
            ? Var2Char(aItem[i])+CRLF

         CASE i = CLASS_DESCR_SUPERCLASSES
            ? "CLASS_DESCR_SUPERCLASSES"
            FOR j := 1 TO jMax
               ? Var2Char(aItem[i][j])
            NEXT
            ? CRLF

         CASE i = CLASS_DESCR_MEMBERS
            ? "CLASS_DESCR_MEMBERS"
            ASort( aItem[i] ,,,{|x,y| Upper( x[CLASS_MEMBER_NAME] ) < ;
                                      Upper( y[CLASS_MEMBER_NAME] ) } )
            FOR j := 1 TO jMax

               DO CASE
                  CASE aItem[i][j][CLASS_MEMBER_ATTR] == VAR_ASSIGN_HIDDEN
                     cAttr := "H"
                  CASE aItem[i][j][CLASS_MEMBER_ATTR] == VAR_ASSIGN_PROTECTED
                     cAttr := "P"
                  CASE aItem[i][j][CLASS_MEMBER_ATTR] == VAR_ASSIGN_EXPORTED
                     cAttr := "X"
               OTHERWISE
                  cAttr := " "
               ENDCASE

               cName := Var2Char(aItem[i][j][CLASS_MEMBER_NAME])
               ? cAttr,cName, oObj:&(cName)

*                  Var2Char(aItem[i][j][CLASS_MEMBER_ATTR]),;
*                  Var2Char(aItem[i][j][CLASS_MEMBER_TYPE])
            NEXT
            ? CRLF

         CASE i = CLASS_DESCR_METHODS
            ? "CLASS_DESCR_METHODS"
            ASort( aItem[i] ,,,{|x,y| Upper( x[CLASS_METHOD_NAME] ) < ;
                                      Upper( y[CLASS_METHOD_NAME] ) } )

            FOR j := 1 TO jMax

               DO CASE
                  CASE aItem[i][j][CLASS_METHOD_ATTR] == VAR_ASSIGN_HIDDEN
                     cAttr := "H"
                  CASE aItem[i][j][CLASS_METHOD_ATTR] == VAR_ASSIGN_PROTECTED
                     cAttr := "P"
                  CASE aItem[i][j][CLASS_METHOD_ATTR] == VAR_ASSIGN_EXPORTED
                     cAttr := "X"
               OTHERWISE
                  cAttr := " "
               ENDCASE

               cName := Var2Char(aItem[i][j][CLASS_METHOD_NAME]   )
               ? cAttr,cName

*                  Var2Char(aItem[i][j][CLASS_METHOD_ATTR]   ) ,;
*                  Var2Char(aItem[i][j][CLASS_METHOD_BLOCK]  ) ,;
*                  Var2Char(aItem[i][j][CLASS_METHOD_VARNAME]) ,;
*                  Var2Char(aItem[i][j][CLASS_METHOD_TYPES]  )
            NEXT
            ? CRLF
      ENDCASE
   NEXT

RETURN

*
*
*